/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package uam.pvoe.sw.tablasCadenas.operaciones;

import java.util.LinkedList;
import java.util.Vector;
import uam.pvoe.sw.tablasCadenas.modelo.Alumno;
import uam.pvoe.sw.tablasCadenas.modelo.AlumnoExamen;
import uam.pvoe.sw.tablasCadenas.modelo.Examen;


/**
 *
 * @author josue
 */
public class LlenarTabla {
    
    /*
     * Llena los datos de los títulos de las
     * columnas a partir de los nombres de los
     * exámenes
     */
    public Vector<String>tituloColumnas(){
        Vector<String>listaTitulos = new Vector();
        
        CargaArchivos cargar = new CargaArchivos();
        LinkedList<Examen>listaExamenes = new LinkedList();
        listaExamenes = cargar.listaExamenes();
        String nombreExamen = "";
        
        for(int i=0;i<listaExamenes.size();i++){
            Examen examenAux = listaExamenes.get(i);
            
            nombreExamen = examenAux.getNombre();
            listaTitulos.add(nombreExamen);
        }
        
        listaTitulos.add(0, "Alumno");

        
        listaTitulos.add(listaTitulos.size(),"Promedio");
       
        return listaTitulos;
        
    }
    
    /*
     * Llena los datos de la celda a partir de la
     * información de los alumnos, los exámenes
     * y las calificaciones de cada alumno 
     * para cada examen
     */
    public Vector<String>elementosCelda(){
         Vector filas = new Vector();
         Vector<String>fila;
          CargaArchivos cargar = new CargaArchivos();
          
          String cadena = "";
          
         LinkedList<Alumno>listaAlumnos = new LinkedList();
         LinkedList<Examen>listaExamenes = new LinkedList();
         LinkedList<AlumnoExamen>listaCalificaciones = new LinkedList();
  
         int nAlumnos;

         listaAlumnos = cargar.listaAlumnos();
         nAlumnos = listaAlumnos.size();
         
         listaExamenes = cargar.listaExamenes();
         float nExamenes = listaExamenes.size();
         
         listaCalificaciones = cargar.listaCalificaciones();
       
         for(int i=0;i<nAlumnos;i++){
             fila = new Vector();
             
             Alumno alumno = listaAlumnos.get(i);
             cadena = alumno.getNombre() + " " + alumno.getPrimerApellido() + " " + alumno.getSegundoApellido();
             
             float promedioAlumno = 0F;
             int sumatoria = 0;
             fila.add(cadena);
             
             int contadorAux = 0;
             
             for(int j=contadorAux;j<listaCalificaciones.size();j++){
                 
                 AlumnoExamen aluEx = listaCalificaciones.get(j);
                 if(aluEx.getId_alumno() == alumno.getId_alumno()){
                     String elemento = new String();
                    
                     if(aluEx.getCalificacion().compareTo("NA") == 0){
                         elemento = "0";
                     }else{
                         elemento = aluEx.getCalificacion();
                     }
                     
                     sumatoria += Integer.parseInt(elemento);
                     promedioAlumno = sumatoria/nExamenes;

                     contadorAux += 1;
                     fila.add(elemento);
                     
                 }
                 aluEx = new AlumnoExamen();
                 
             }
             String promedio = new String();
             promedio = ""+promedioAlumno;
             fila.add(promedio);
             
             alumno = new Alumno();
             filas.add(fila);
         }
         
         
         return filas;
        
    }
    
    
}
